Bug-144 -- set the URL for loganalyzer
[osm/SO.git] / BUILD.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright 2016 RIFT.IO Inc
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 # http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16 #
17 # Author(s): Jeremy Mordkoff, Lezz Giles
18 # Creation Date: 08/29/2016
19 #
20 #
21
22 # BUILD.sh
23 #
24 # This is a top-level build script for RIFT.io
25 #
26 # Arguments and options: use -h or --help
27 #
28 # dependencies -- requires sudo rights
29
30 # Defensive bash programming flags
31 set -o errexit # Exit on any error
32 trap 'echo ERROR: Command failed: \"$BASH_COMMAND\"' ERR
33 set -o nounset # Expanding an unset variable is an error. Variables must be
34 # set before they can be used.
35
36 ###############################################################################
37 # Options and arguments
38
39 # There
40 params="$(getopt -o suhb: -l install-so,install-ui,no-mkcontainer,build-ui:,help --name "$0" -- "$@")"
41 if [ $? != 0 ] ; then echo "Failed parsing options." >&2 ; exit 1 ; fi
42
43 eval set -- $params
44
45 installSO=false
46 installUI=false
47 runMkcontainer=true
48 UIPathToBuild=
49
50 while true; do
51 case "$1" in
52 -s|--install-so) installSO=true; shift;;
53 -u|--install-ui) installUI=true; shift;;
54 -b|--build-ui) shift; UIPathToBuild=$1; shift;;
55 --no-mkcontainer) runMkcontainer=false; shift;;
56 -h|--help)
57 echo
58 echo "NAME:"
59 echo " $0"
60 echo
61 echo "SYNOPSIS:"
62 echo " $0 -h|--help"
63 echo " $0 [-s] [-u|-b PATH-TO-UI-REPO] [PLATFORM_REPOSITORY] [PLATFORM_VERSION]"
64 echo
65 echo "DESCRIPTION:"
66 echo " Prepare current system to run SO and UI. By default, the system"
67 echo " is set up to support building SO and UI; optionally, either or"
68 echo " both SO and UI can be installed from a Debian package repository."
69 echo
70 echo " -s|--install-so: install SO from package"
71 echo " -u|--install-ui: install UI from package"
72 echo " -b|--build-ui PATH-TO-UI-REPO: build the UI in the specified repo"
73 echo " --no-mkcontainer: do not run mkcontainer, used for debugging script"
74 echo " PLATFORM_REPOSITORY (optional): name of the RIFT.ware repository."
75 echo " PLATFORM_VERSION (optional): version of the platform packages to be installed."
76 echo
77 exit 0;;
78 --) shift; break;;
79 *) echo "Not implemented: $1" >&2; exit 1;;
80 esac
81 done
82
83 if $installUI && [[ $UIPathToBuild ]]; then
84 echo "Cannot both install and build the UI!"
85 exit 1
86 fi
87
88 if [[ $UIPathToBuild && ! -d $UIPathToBuild ]]; then
89 echo "Not a directory: $UIPathToBuild"
90 exit 1
91 fi
92
93 # Turn this on after handling options, so the output doesn't get cluttered.
94 set -x # Print commands before executing them
95
96 ###############################################################################
97 # Find the platform
98 PYTHON=python
99 if [[ ! -f /usr/bin/python ]]; then
100 PYTHON=python3
101 fi
102
103 if $PYTHON -mplatform | grep -qi fedora; then
104 PLATFORM=fc20
105 elif $PYTHON -mplatform | grep -qi ubuntu; then
106 PLATFORM=ub16
107 else
108 echo "Unknown platform"
109 exit 1
110 fi
111
112 ###############################################################################
113 # Set up repo and version
114
115 if [[ $PLATFORM == ub16 ]]; then
116 PLATFORM_REPOSITORY=${1:-OSM}
117 PLATFORM_VERSION=${2:-4.3.1.0.53704}
118 elif [[ $PLATFORM == fc20 ]]; then
119 PLATFORM_REPOSITORY=${1:-OSM} # change to OSM when published
120 PLATFORM_VERSION=${2:-4.3.1.0.53705}
121 else
122 echo "Internal error: unknown platform $PLATFORM"
123 exit 1
124 fi
125
126 ###############################################################################
127 # Main block
128
129 # Disable apt-daily.service and apt-daily.timer
130
131 DAILY_TIMER='apt-daily.timer'
132 DAILY_SERVICE='apt-daily.service'
133 if [ $(systemctl is-active $DAILY_TIMER) = "active" ]
134 then
135 systemctl stop $DAILY_TIMER
136 systemctl disable $DAILY_TIMER
137 systemctl disable $DAILY_SERVICE
138 fi
139
140 # must be run from the top of a workspace
141 cd $(dirname $0)
142
143 # inside RIFT.io this is an NFS mount
144 # so just to be safe
145 test -h /usr/rift && sudo rm -f /usr/rift
146
147 if [[ $PLATFORM == ub16 ]]; then
148 # enable the right repos
149 curl http://repos.riftio.com/public/xenial-riftware-public-key | sudo apt-key add -
150 # the old mkcontainer always enabled release which can be bad
151 # so remove it
152 sudo rm -f /etc/apt/sources.list.d/release
153 sudo curl -o /etc/apt/sources.list.d/${PLATFORM_REPOSITORY}.list http://buildtracker.riftio.com/repo_file/ub16/${PLATFORM_REPOSITORY}/
154 sudo apt-get update
155
156 # and install the tools
157 sudo apt remove -y rw.toolchain-rwbase tcpdump
158 sudo apt-get install -y --allow-downgrades rw.tools-container-tools=${PLATFORM_VERSION} rw.tools-scripts=${PLATFORM_VERSION} python
159 elif [[ $PLATFORM == fc20 ]]; then
160 # get the container tools from the correct repository
161 sudo rm -f /etc/yum.repos.d/private.repo
162 sudo curl -o /etc/yum.repos.d/${PLATFORM_REPOSITORY}.repo \
163 http://buildtracker.riftio.com/repo_file/fc20/${PLATFORM_REPOSITORY}/
164 sudo yum install --assumeyes rw.tools-container-tools rw.tools-scripts
165 else
166 echo "Internal error: unknown platform $PLATFORM"
167 exit 1
168 fi
169
170 # enable the OSM repository hosted by RIFT.io
171 # this contains the RIFT platform code and tools
172 # and install of the packages required to build and run
173 # this module
174 if $runMkcontainer; then
175 sudo apt-get install -y libxml2-dev libxslt-dev
176 sudo /usr/rift/container_tools/mkcontainer --modes build --modes ext --repo ${PLATFORM_REPOSITORY}
177 sudo pip3 install lxml==3.4.0
178 fi
179
180
181 if [[ $PLATFORM == ub16 ]]; then
182 # install the RIFT platform code:
183 # remove these packages since some files moved from one to the other, and one was obsoleted
184 # ignore failures
185
186 PACKAGES="rw.toolchain-rwbase rw.toolchain-rwtoolchain rw.core.mgmt-mgmt rw.core.util-util \
187 rw.core.rwvx-rwvx rw.core.rwvx-rwdts rw.automation.core-RWAUTO rw.core.rwvx-rwha-1.0"
188 # this package is obsolete.
189 OLD_PACKAGES=""
190 for package in $PACKAGES $OLD_PACKAGES; do
191 sudo apt remove -y $package || true
192 done
193
194 packages=""
195 for package in $PACKAGES; do
196 packages="$packages $package=${PLATFORM_VERSION}"
197 done
198 sudo apt-get install -y --allow-downgrades $packages
199
200 sudo apt-get install python-cinderclient
201
202 sudo chmod 777 /usr/rift /usr/rift/usr/share
203
204 if $installSO; then
205 sudo apt-get install -y \
206 rw.core.mc-\*=${PLATFORM_VERSION}
207 fi
208
209 if $installUI; then
210 sudo apt-get install -y \
211 rw.ui-about=${PLATFORM_VERSION} \
212 rw.ui-logging=${PLATFORM_VERSION} \
213 rw.ui-skyquake=${PLATFORM_VERSION} \
214 rw.ui-accounts=${PLATFORM_VERSION} \
215 rw.ui-composer=${PLATFORM_VERSION} \
216 rw.ui-launchpad=${PLATFORM_VERSION} \
217 rw.ui-debug=${PLATFORM_VERSION} \
218 rw.ui-config=${PLATFORM_VERSION} \
219 rw.ui-dummy_component=${PLATFORM_VERSION}
220 fi
221 elif [[ $PLATFORM == fc20 ]]; then
222
223 temp=$(mktemp -d /tmp/rw.XXX)
224 pushd $temp
225
226 # yum does not accept the --nodeps and --replacefiles options so we
227 # download first and then install
228 yumdownloader rw.toolchain-rwbase-${PLATFORM_VERSION} \
229 rw.toolchain-rwtoolchain-${PLATFORM_VERSION} \
230 rw.core.mgmt-mgmt-${PLATFORM_VERSION} \
231 rw.core.util-util-${PLATFORM_VERSION} \
232 rw.core.rwvx-rwvx-${PLATFORM_VERSION} \
233 rw.core.rwvx-rwha-1.0-${PLATFORM_VERSION} \
234 rw.core.rwvx-rwdts-${PLATFORM_VERSION} \
235 rw.automation.core-RWAUTO-${PLATFORM_VERSION}
236
237 # Install one at a time so that pre-installed packages will not cause a failure
238 for pkg in *rpm; do
239 # Check to see if the package is already installed; do not try to install
240 # it again if it does, since this causes rpm -i to return failure.
241 if rpm -q $(rpm -q -p $pkg) >/dev/null; then
242 echo "WARNING: package already installed: $pkg"
243 else
244 sudo rpm -i --replacefiles --nodeps $pkg
245 fi
246 done
247
248 popd
249 rm -rf $temp
250
251 # this file gets in the way of the one generated by the build
252 sudo rm -f /usr/rift/usr/lib/libmano_yang_gen.so
253
254
255 sudo chmod 777 /usr/rift /usr/rift/usr/share
256
257 if $installSO; then
258 sudo apt-get install -y \
259 rw.core.mc-\*-${PLATFORM_VERSION}
260 fi
261
262 if $installUI; then
263 sudo apt-get install -y \
264 rw.ui-about-${PLATFORM_VERSION} \
265 rw.ui-logging-${PLATFORM_VERSION} \
266 rw.ui-skyquake-${PLATFORM_VERSION} \
267 rw.ui-accounts-${PLATFORM_VERSION} \
268 rw.ui-composer-${PLATFORM_VERSION} \
269 rw.ui-launchpad-${PLATFORM_VERSION} \
270 rw.ui-debug-${PLATFORM_VERSION} \
271 rw.ui-config-${PLATFORM_VERSION} \
272 rw.ui-dummy_component-${PLATFORM_VERSION}
273 fi
274
275 else
276 echo "Internal error: unknown platform $PLATFORM"
277 exit 1
278 fi
279
280 # install some base files used to create VNFs
281 test -d /usr/rift/images || mkdir /usr/rift/images
282 for file in Fedora-x86_64-20-20131211.1-sda-ping.qcow2 Fedora-x86_64-20-20131211.1-sda-pong.qcow2 Fedora-x86_64-20-20131211.1-sda.qcow2; do
283 test -f /usr/rift/images/$file || curl -o /usr/rift/images/$file http://repo.riftio.com/releases/open.riftio.com/4.3.1/$file
284 done
285
286 # If you are re-building SO, you just need to run
287 # these two steps
288 if ! $installSO; then
289 make -j16
290 sudo make install
291 fi
292
293 if [[ $UIPathToBuild ]]; then
294 make -C $UIPathToBuild -j16
295 sudo make -C $UIPathToBuild install
296 fi
297
298 echo "Creating Service ...."
299 sudo $(dirname $0)/create_launchpad_service
300